// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

int R, S, P=1000000009, N, K;

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  scanf("%d%d%d",&R,&S,&N);
  while (N--) {
    vector< vector<int> > C(R+1, vector<int>(S+1,0) );
    scanf("%d",&K);
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      C[x][y] = -1;
    }
    for (int r=0; r<=R; ++r)
      for (int s=0; s<=S; ++s)
        if (C[r][s]==-1)
          C[r][s]=0;
        else if (r==0 && s==0)
          C[r][s] = 1;
        else if (r==0)
          C[r][s] = C[r][s-1];
        else if (s==0)
          C[r][s] = C[r-1][s];
        else {
          C[r][s] = C[r-1][s] + C[r][s-1];
          if (C[r][s] > P) C[r][s] -= P;
        }
    cout << C[R][S] << endl;
  }
}
