// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

int R, S, P=1000000009, N, K;

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  scanf("%d%d%d",&R,&S,&N);
  vector< vector<int> > C(R+1, vector<int>(S+1,0) );
  for (int r=0; r<=R; ++r)
    for (int s=0; s<=S; ++s)
      if (r==0 || s==0)
        C[r][s] = 1;
      else {
        C[r][s] = C[r-1][s] + C[r][s-1];
        if (C[r][s] > P) C[r][s] -= P;
      }
  while (N--) {
    scanf("%d",&K);
    vector< pair<int,int> > prekazky;
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      prekazky.push_back( make_pair(x,y) );
    }
    sort( prekazky.begin(), prekazky.end(), distless );
    long long result = 0;
    for (int cez=0; cez<(1<<K); ++cez) {
      int sign = (__builtin_popcount(cez)&1) ? -1 : 1;
      long long poc = 1;
      int X[K+2], Y[K+2], ZC=0;
      X[ZC]=0; Y[ZC]=0; ++ZC;
      for (int k=0; k<K; ++k) if (cez & 1<<k) { X[ZC]=prekazky[k].first; Y[ZC]=prekazky[k].second; ++ZC; }
      X[ZC]=R; Y[ZC]=S; ++ZC;
      for (int z=0; z<ZC-1; ++z) {
        int toto = 0;
        if (X[z+1] >= X[z] && Y[z+1] >= Y[z]) toto = C[ X[z+1]-X[z] ][ Y[z+1]-Y[z] ];
        poc *= toto;
        poc %= P;
      }
      result += sign * poc;
      result %= P;
    }
    result += P;
    result %= P;
    cout << result << endl;
  }
}
