// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

int R, S, P=1000000009, N, K;

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  scanf("%d%d%d",&R,&S,&N);
  while (N--) {
    vector< vector<int> > C(R+1, vector<int>(S+1,0) );
    scanf("%d",&K);
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      C[x][y] = -1;
    }
    int Z[R+S];
    for (int r=0; r<R; ++r) Z[r]=0;
    for (int s=0; s<S; ++s) Z[R+s]=1;
    long long result = 0;
    do {
      bool ok = true;
      int r=0, s=0;
      for (int x=0; x<R+S; ++x) {
        if (Z[x]) ++s; else ++r;
        if (C[r][s]==-1) { ok=false; break; }
      }
      if (ok) ++result;
    } while (next_permutation(Z,Z+R+S));
    cout << (result%P) << endl;
  }
}
